<?php
require_once( '../../../wp-config.php' );
require_once( dirname(__FILE__) . '/openid-classes.php' );

if( isset($_GET['openid_logout'] ) )
{
	if( isset( $_GET['post_id'] ) )
		$location = get_permalink( $_GET['post_id'] );
	elseif( empty( $_POST['redirect_to'] ) )
		$location = get_settings( 'siteurl' );
	else
		$location = $_POST['redirect_to'];

	setcookie( 'openid_name_' . COOKIEHASH, '', time() + 30000000, COOKIEPATH, COOKIE_DOMAIN );
	setcookie( 'openid_identity_' . COOKIEHASH, '', time() + 30000000, COOKIEPATH, COOKIE_DOMAIN );

	setcookie('comment_author_' . COOKIEHASH, '', time() + 30000000, COOKIEPATH, COOKIE_DOMAIN);
	setcookie('comment_author_email_' . COOKIEHASH, '', time() + 30000000, COOKIEPATH, COOKIE_DOMAIN);
	setcookie('comment_author_url_' . COOKIEHASH, '', time() + 30000000, COOKIEPATH, COOKIE_DOMAIN);

	wp_redirect( $location );
} 

if( !isset( $_GET['openid_mode'] ) )
{
	nocache_headers();

	$comment_post_ID = (int) $_POST['comment_post_ID'];

	$status = $wpdb->get_row("SELECT post_status, comment_status FROM $wpdb->posts WHERE ID = '$comment_post_ID'");

	if( empty($status->comment_status) )
	{
		do_action('comment_id_not_found', $comment_post_ID);
		exit;
	}
	elseif( 'closed' ==  $status->comment_status )
	{
		do_action('comment_closed', $comment_post_ID);
		die( __('Sorry, comments are closed for this item.') );
	}
	elseif( 'draft' == $status->post_status )
	{
		do_action('comment_on_draft', $comment_post_ID);
		exit;
	}

	$comment_author       = trim($_POST['author']);
	$comment_author_email = trim($_POST['email']);
	$comment_author_url   = trim($_POST['url']);
	$comment_content      = trim($_POST['comment']);

	// If the user is logged in
	get_currentuserinfo();
	if( $user_ID )
	{
		$comment_author       = $wpdb->escape($user_identity);
		$comment_author_email = $wpdb->escape($user_email);
		$comment_author_url   = $wpdb->escape($user_url);
	}
	else if( $_COOKIE['openid_name_' . COOKIEHASH] != '' )
	{
		$data['comment_content'] = $comment_content;
		$data['comment_author_email'] = $comment_author_email;
		$data['comment_post_ID'] = $comment_post_ID;
		$data['subscribe'] = $_POST['subscribe'];
		$data['removesubscrips'] = $_POST['removesubscrips'];
		$data['subscrips'] = $_POST['subscrips'];
		$data['removeBlock'] = $_POST['removeBlock'];
		$data['comment_reply_ID'] = $_REQUEST['comment_reply_ID'];

		$return_to = isset( $_SERVER['SCRIPT_URI'] ) ? $_SERVER['SCRIPT_URI']: 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];

		OpenIDConsumer::check_identity( $_COOKIE['openid_identity_' . COOKIEHASH], get_settings( 'siteurl' ), $return_to, $data, true );
	}
	else
	{
		if ( get_option('comment_registration') && !isset($_POST['openid_name']) )
			die( __('Sorry, you must be logged in to post a comment.') );
	}

	// Check if there is openid name and try to login with it
	if( $comment_author == '' && isset( $_POST['openid_name'] ) )
	{
		$data['comment_content'] = $comment_content;
		$data['comment_author_email'] = $comment_author_email;
		$data['comment_post_ID'] = $comment_post_ID;
		$data['subscribe'] = $_POST['subscribe'];
		$data['removesubscrips'] = $_POST['removesubscrips'];
		$data['subscrips'] = $_POST['subscrips'];
		$data['removeBlock'] = $_POST['removeBlock'];
		$data['comment_reply_ID'] = $_REQUEST['comment_reply_ID'];

		$identity_url = OpenIDConsumer::create_identity_url( trim( $_POST['openid_type'] ), trim( $_POST['openid_name'] ) );
		$return_to = isset( $_SERVER['SCRIPT_URI'] ) ? $_SERVER['SCRIPT_URI']: 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];

		OpenIDConsumer::check_identity( $identity_url, get_settings( 'siteurl' ), $return_to, $data, false );
	}

	$comment_type = '';

	if( get_settings('require_name_email') && !$user_ID && $_SESSION['sess_openid_auth_code'] == '' && $_COOKIE['openid_auth_code'] == '' )
	{
		if ( 6 > strlen($comment_author_email) || '' == $comment_author )
			die( __('Error: please fill the required fields (name, email).') );
		elseif ( !is_email($comment_author_email))
			die( __('Error: please enter a valid email address.') );
	}

	if('' == $comment_content)
		die( __('Error: please type a comment.') );

	$commentdata = compact('comment_post_ID', 'comment_author', 'comment_author_email', 'comment_author_url', 'comment_content', 'comment_type', 'user_ID');

	wp_new_comment( $commentdata );

	if( !$user_ID ) :
		setcookie('comment_author_' . COOKIEHASH, stripslashes($comment_author), time() + 30000000, COOKIEPATH, COOKIE_DOMAIN);
		setcookie('comment_author_email_' . COOKIEHASH, stripslashes($comment_author_email), time() + 30000000, COOKIEPATH, COOKIE_DOMAIN);
		setcookie('comment_author_url_' . COOKIEHASH, stripslashes($comment_author_url), time() + 30000000, COOKIEPATH, COOKIE_DOMAIN);
	endif;

	$location = ( empty( $_POST['redirect_to'] ) ) ? get_permalink( $comment_post_ID ) : $_POST['redirect_to']; 

	wp_redirect( $location );
}
else if( isset($_GET['openid_mode']) )
{
	if( $_GET['openid_mode'] == 'id_res' )
	{
		$query = array_merge( $_GET, $_POST );
		$result = OpenIDConsumer::login( $query );

		setcookie( 'openid_name_' . COOKIEHASH, $result['openid_name'], time() + 30000000, COOKIEPATH, COOKIE_DOMAIN );
		setcookie( 'openid_identity_' . COOKIEHASH, $result['openid_identity'], time() + 30000000, COOKIEPATH, COOKIE_DOMAIN );

		$comment_author 		= $result['openid_name'];
		$comment_author_email	= $result['comment_author_email'];
		$comment_author_url		= $result['openid_identity'];
		$comment_content		= $result['comment_content'];
		$comment_post_ID		= $result['comment_post_ID'];

		if( $comment_author == '' )
			die( "Couldn't leave comment with this OpenID name\n" );

		if( isset( $result['subscribe'] ) )
			$_POST['subscribe'] = $result['subscribe'];
		if( isset( $result['removesubscrips'] ) )
			$_POST['removesubscrips'] = $result['removesubscrips'];
		if( isset( $result['subscrips'] ) )
			$_POST['subscrips'] = $result['subscrips'];
		if( isset( $result['removeBlock'] ) )
			$_POST['removeBlock'] = $result['removeBlock'];
		if( isset( $result['comment_reply_ID'] ) )
			$_REQUEST['comment_reply_ID'] = $result['comment_reply_ID'];

		$commentdata = compact('comment_post_ID', 'comment_author', 'comment_author_email', 'comment_author_url', 'comment_content', 'comment_type', 'user_ID');

		wp_new_comment( $commentdata );

		$location = ( empty( $_POST['redirect_to'] ) ) ? get_permalink( $comment_post_ID ) : $_POST['redirect_to']; 

		wp_redirect( $location );
	}
	else if( $_GET['openid_mode'] == 'cancel' )
	{
		$location = ( empty( $_POST['redirect_to'] ) ) ? get_permalink( $_SESSION['sess_openid_post'] ) : $_POST['redirect_to'];
		wp_redirect( $location );
	}
}
?>

