<?php
/*
	Plugin Name: OpenID Comments for WordPress
	Plugin URI: http://the-notebook.org/12/01/2006/openid-comments-for-wordpress/
	Description: This plugin will allow users to leave comments using their OpenID identities. Based on OpenID for WordPress by Dan Huntley (<a href="http://www.scatmania.org/">http://www.scatmania.org/</a>)
	Author: Alexander Nikulin
	Version: 0.9.1
	Author URI: http://the-notebook.org/
*/ 

function openid_install()
{
	global $table_prefix, $wpdb;
	require_once( ABSPATH . 'wp-admin/upgrade-functions.php' );	 

	// Association handles table (for consumer)
	$table_name1 = $table_prefix . 'openid_assoc_handles';
	if( $wpdb->get_var("show tables like '$table_name1'") != $table_name1 ) 
	{
		$wpdb->query( 'DROP TABLE IF EXISTS '.$table_name1 ); 

		// Create the table
		$sql = 'CREATE TABLE '.$table_name1.' (
				server_url VARCHAR(255) NOT NULL,
				assoc_handle TEXT NOT NULL,
				secret VARCHAR(255) NOT NULL,
				expires_at INT NOT NULL,
				UNIQUE(server_url)
				);'; 

		dbDelta( $sql );
	}

	// Associations table (for server)
	$table_name2 = $table_prefix . 'openid_associations';
	if( $wpdb->get_var("show tables like '$table_name2'") != $table_name2 ) 
	{
		$wpdb->query( 'DROP TABLE IF EXISTS '.$table_name2 ); 

		// Create the table
		$sql = 'CREATE TABLE '.$table_name2.' (
				assoc_handle VARCHAR(255) NOT NULL,
				secret VARCHAR(20) NOT NULL,
				expires_at INT NOT NULL,
				UNIQUE(assoc_handle)
				);'; 

		dbDelta( $sql );
	}

	// Trust table (for server)
	$table_name3 = $table_prefix . 'openid_trust';
	if( $wpdb->get_var("show tables like '$table_name3'") != $table_name3 ) 
	{
		$wpdb->query( 'DROP TABLE IF EXISTS '.$table_name3 ); 

		// Create the table
		$sql = 'CREATE TABLE '.$table_name3.' (
				identity VARCHAR(255) NOT NULL,
				trust_root VARCHAR(255) NOT NULL
				);'; 

		dbDelta( $sql );
	}

	echo '<div class="updated"><p> OpenID Comments for Wordpress was installed.<br />If you deactivate the plugin later, make sure to delete database tables '. $table_name1 . ', ' . $table_name2 . ' and ' . $table_name3 . ' (after deactivating the plugin).</p></div>';
}

function add_server_info( $content )
{
	$server_info = '<link rel="openid.server" href="' . get_settings('siteurl') . '/wp-content/plugins/openid/server.php/"/>';
	echo $server_info;
}

if( isset( $_GET['activate'] ) && $_GET['activate'] == 'true' )
{
	add_action( 'init', 'openid_install' );
}
add_filter( 'wp_head', 'add_server_info' );
?>