<?php
require( '../../../wp-config.php' );
require_once( dirname(__FILE__) . '/openid-classes.php' );

$query = array_merge( $_POST, $_GET );

$_SERVER['SCRIPT_URI'] = isset( $_SERVER['SCRIPT_URI'] ) ? $_SERVER['SCRIPT_URI']: 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];

if( isset( $query['operation'] ) )
{
	if( !OpenIDServer::is_identity_valid( $query ) )
		die( 'Couldn\'t verify OpenID identity.' );

	$operation = $query['operation'];
	if( $operation == 'ask_trust' )
	{
		include TEMPLATEPATH . '/openidtrustpage.php';
	}
	else if( $operation == 'trust_result' )
	{
		$params = array();
		foreach( $query as $key => $value )
		{
			if( $key != 'operation' && $key != 'trust_result' && $key != 'trust_once' && $key != 'trust_always' )
				$params[$key] = $value;
		}

		$params['trust'] = 'cancel';

		if( isset( $query['trust_once'] ) )
		{
			$params['trust'] = 'yes';
		}
		else if( isset( $query['trust_always'] ) )
		{
			OpenIDServer::trust_always( $query );

			$params['trust'] = 'yes';
		}

		$redirect = $_SERVER['SCRIPT_URI'] . '?' . http_build_query( $params );
		header( 'Location: ' . $redirect );
		exit;
	}
}
else if( isset( $query['openid_mode'] ) )
{
	$mode = $query['openid_mode'];
	if( $mode == 'associate' )
	{
		$assoc_info = OpenIDServer::associate();

		$response['assoc_type'] = 'HMAC-SHA1';
		$response['assoc_handle'] = $assoc_info['assoc_handle'];
		$response['mac_key'] = base64_encode( $assoc_info['secret'] );
		$response['expires_in'] = $assoc_info['expires_at'] - time();

		$body = '';
		foreach( $response as $key => $value )
			$body .= sprintf( "%s:%s\n", $key, $value );
			
		echo $body;
	}
	else if( strstr( $mode, 'check' ) )
	{
		if( $mode != 'check_authentication' )
		{
			if( !OpenIDServer::is_identity_valid( $query ) )
			{
				if( $mode == 'checkid_immediate' )
				{
					$setup_url = get_settings( 'siteurl' ) . '/wp-login.php';
					$sep = strchr( $query['openid_return_to'], '?' ) ? '&': '?';
					$redirect .= $query['openid_return_to'] . $sep . 'openid.mode=id_res' . '&openid.user_setup_url=' . $setup_url;
					header( 'Location: '. $redirect );
					exit;
				}

				die( 'Couldn\'t verify OpenID identity.' );
			}

			if( OpenIDServer::do_i_trust( $query ) )
			{
				if( $mode == 'checkid_setup' )
				{
					$redirect = OpenIDServer::checkid_setup( $query, 'id_res' );
				}
				else if( $mode == 'checkid_immediate' )
				{
					$redirect = OpenIDServer::checkid_setup( $query, 'id_res' );
				}

				if( $redirect == '' )
					die( 'Couldn\'t verify OpenID identity.' );

				header( 'Location: ' . $redirect );
				exit;
			}
			else
			{
				if( isset( $query['trust'] ) && $query['trust'] = 'cancel' )
					$redirect = OpenIDServer::checkid_setup( $query, 'cancel' );
				else
					$redirect = $_SERVER['SCRIPT_URI'] . '?operation=ask_trust&' . http_build_query( $query );

				header( 'Location: ' . $redirect );
				exit;
			}
		}
		else
		{
			echo OpenIDServer::check_authentication( $query );
		}
	}
}

?>